
// imports the libraries
import de.bezier.data.*;
import gifAnimation.*;
import ddf.minim.*;
//The reader
XlsReader reader;
//Sound files
Minim minim;
AudioSample BtnSnd;
AudioSample ResetSnd;
AudioSample MinerSnd;
//Images and fonts
PImage backgroundDay;
PImage backgroundTint;
PImage backgroundNight;
PImage plan;
PImage minerStandby;
PImage minerStandbyStatic;
PImage minerMove;
PImage treeStronglyDisagree;
PImage treeDisagree;
PImage treeNeutral;
PImage treeAgree;
PImage[] buildingStore;//stores one of each building type
PImage[] buildings;//contains random copies of the stored buildings for each set of data, the pixels of these images will be edited
PImage[] buildingsGhosts;// contains a copy of the same buildings in the buildings[][] array, but will stay unedited
Gif[] people;
PFont headings;
PFont headingTop;
PFont status;
Gif standbyAnimation;
Gif miningAnimation;

int screenSizeX = 1200;
int screenSizeY = 615;
//scales for stretching buildings, moving the miner, and changing the background opacity
int buildingScaleY = 0;
int buildingScaleMax = 100;
int minerOffsetY = 0; 
double minerFlash = 0;
float backGroundTime = 0.0;
float arcD = 300f;

boolean stickyLeft = false;
boolean stickyRight = false;
int stickyTimerLeft =0;
int stickyTimerRight =0;
String stickyTextLeft ="";
String stickyTextRight ="";
int stickyColourLeft =0;
int stickyColourRight =0;

//a timer for ball creation
int ballTimer = 0;
//boolean false for different states of the program
boolean doneBuilding = false;
boolean startMining = false;
boolean reachedMine = false;
//Y coordinate for labes
int lableY = 550;

//outline rectangles and positions for layout
int economyW = 46;
int wasteH = 41;
int headingH = 60;
int rectH = 100;

int resetTimer = 0;
//width of each info bar
int barW = 40;

float sideBufferY = 5;
float sideBufferX = 5;
float dumpHeight = 70;
float dumpWidth = screenSizeX/5 + sideBufferX/4 ;
float barDividerY = 20;

float dumpQaudSpace = 60;
float dumpQaudOffset = 0;

float minerWidth = 38;
float minerDistance = 50; 

//arrays to keep in data and labels. Labels being the "agree, disagree etc in the excel sheet
int [][] data;
float [][] dataPercent;
int [][] dataTotal;
String [] labels;
float pieSpinTimer = 0;

// game frame width and height

int gameFrameWidth = 270;
int gameFrameHeight = 370;

//a variable used to help the balls know what game frame they belong to
int set = 0;

//timers and boolean for playing sound
int soundTimer = 0;
boolean playingSound = false;

//an array of GameFrames, check containing its own list of buildings and balls
GameFrame frame;
//a seperate set of balls to bounce around the miners


//variables to make the miners flash at the start
float c1 = 0;        
float c1dir = 0.8;  

float bl = 0.2;



void setup () 
{
  noStroke();
  //set frame rate and screen dimensions
  frameRate(60);
  size (screenSizeX,screenSizeY);
  
  //setup sound clips
  minim = new Minim(this);
  BtnSnd = minim.loadSample( "desk.wav");
  ResetSnd = minim.loadSample( "metalhit.wav");
  MinerSnd = minim.loadSample( "166510__yoyodaman234__dirt-gravel-footstep-2.wav");
  
  //load fonts
  headingTop = loadFont ("Fineness-Bold-28.vlw");
  headings = loadFont ("Fineness-Bold-22.vlw");
  status = loadFont ("Fineness-Bold-18.vlw");
  
   //load images
  backgroundDay = loadImage ("Background day.jpg");
  backgroundTint = loadImage ("Background sunriset.jpg");
  backgroundNight = loadImage ("Background night.jpg");
  minerStandby = loadImage ("Miner-standby.gif");
  minerStandbyStatic = loadImage ("Miner-standbystatic.png");
  minerMove = loadImage ("Miner-mining.gif");
  
  noStroke();
  
  
  //load array of all buildings
  buildingStore = new PImage[6];
  for(int i = 2; i <=7;i++)
   {
     buildingStore[i-2] = loadImage ("house.png");
   }
   //loads copies of the images stored in buildingStore randomly into each space in buildings, which is then also copied by buildingsGhosts
   buildings = new PImage[3];
   buildingsGhosts = new PImage[3];
   for (int i=0; i<3; i++) // creates one blocks for buildings in each 'status' or answer block
   {
      buildings[i] = buildingStore[(int)(Math.round(Math.random()*5))].get(); // randomizes which buildings are drawn, and ensures that the random number is a whole number 
      buildingsGhosts[i] =buildings[i].get(); // ensures that the building ghosts are the same as the building type which they are under
   }
   //loads the reader and initializes the data arrays
   reader = new XlsReader( this, "datasheet.xls" ); 
   data = new int [5][5];
   dataTotal = new int [2][5];
   dataPercent = new float [2][5];
   labels = new String [5];
  
  
    //creates the game frames and mine balls


     frame = new GameFrame((int)(400),100,26,buildings); 
 
  
  readData ();//reads the data from the excel sheet
  
   //loads and plays our .gif animations
   people = new Gif[2];
   people[0] = new Gif(this,"woman-01-standby.gif");
   people[0].play();
   people[1] = new Gif(this,"woman-02-standby.gif");
   people[1].play();
  standbyAnimation = new Gif(this, "Miner-standby.gif");
  standbyAnimation.play();
  miningAnimation = new Gif(this, "Miner-mining.gif");
  miningAnimation.play();
 
  textFont(status);
}


void draw ()
{
 //draw the base background
 image(backgroundDay,0,0); 
 //draw the overlaying background, which increases in opacity over time.
 tint (255,255,255,backGroundTime);
 if(backGroundTime < 0 || backGroundTime > 510)
   bl = -bl;
 backGroundTime += bl;
 
 image (backgroundTint,0,0);
 
 tint (255,255,255,backGroundTime -255);
 image (backgroundNight,0,0);
 //draw the structure of the display
 drawStructs();
 //draw all the data bars/buildings
 drawData();

 //draw the miners
 minerstandby ();
 //draws the reset buttons
 resetButton ();

  //start adding balls to each game frame and refreshes the game frames, but only if the buildings are done building
  if(doneBuilding)
  {
     frame.refresh();
     ballTimer++;
     addBalls();
  }
  

 //if mouse is not pressed, allow a new sounds to play
 if(mousePressed == false)
 {
   playingSound = false; 
 }
}


//function to draw the basic rectangles at the buttom
void bottomrectangles ()
{
  
 fill (60);//light brown // HEADING CHANGE!!!
 rect(0, height - (dumpHeight*2),width , height);  
 fill (134,110,74);//dark brown // HEADING CHANGE!!!
 rectMode(CORNERS);
 rect(sideBufferX, height - (dumpHeight*2-sideBufferY), sideBufferX+dumpWidth*2, height-(dumpHeight+sideBufferY-barDividerY));    //top left
 rect(sideBufferX, height - (dumpHeight-barDividerY), sideBufferX+dumpWidth*2, height-sideBufferY);     //bottom left
 rect(sideBufferX*2+dumpWidth*2, height - (dumpHeight*2-sideBufferY), sideBufferX + dumpWidth*3 + sideBufferX, height-sideBufferY); //center
 rect(sideBufferX + dumpWidth*3 + sideBufferX*2, height - (dumpHeight*2-sideBufferY), -sideBufferX*2 + dumpWidth*5 , height-(dumpHeight+sideBufferY-barDividerY)); //top right  
 rect(sideBufferX + dumpWidth*3 + sideBufferX*2, height - (dumpHeight-barDividerY), -sideBufferX*2 + dumpWidth*5 , height-sideBufferY);  //bottom right
}

//draws the growing mine dumps
void minedumps ()
{
  fill (196,160,102); //CHANGE DUMP
  quad (sideBufferX + dumpQaudSpace, height - (wasteH+rectH)+1 - (height/2 -wasteH)*minerOffsetY/70, sideBufferX+dumpWidth*2 - dumpQaudSpace, height - (wasteH+rectH)+1 - (height/2 -wasteH)*minerOffsetY/70, sideBufferX+dumpWidth*2, height - (wasteH+rectH)+1, sideBufferX ,height - (wasteH+rectH)+1);
  
  if(doneBuilding && dumpQaudOffset <= 150)
  dumpQaudOffset +=0.2;

  fill (255,224,134);//CHANGE DUMP
  quad (sideBufferX + dumpWidth*3 + sideBufferX*2 + dumpQaudSpace, height - (wasteH+rectH)+1 - (height/2 -wasteH)*minerOffsetY/70 -dumpQaudOffset,  -sideBufferX*2 + dumpWidth*5 - dumpQaudSpace, height - (wasteH+rectH)+1 - (height/2 -wasteH)*minerOffsetY/70 -dumpQaudOffset, -sideBufferX*2 + dumpWidth*5, height - (wasteH+rectH)+1, sideBufferX + dumpWidth*3 + sideBufferX*2 ,height - (wasteH+rectH)+1);
}


//draws the miners
void minerstandby ()
{
  if(minerOffsetY >= 70)//after 70 frames, the miners stop mining down 
  {
   startMining = false;
   reachedMine = true;
  }

  if(startMining == true)//increases the mining timer
   minerOffsetY++;
  
  float minerBaseX = width/2 ;
  
   PImage toDraw;// stores the image we want to draw at the end
   for (int i = 0; i< 3; i++)
   { 
     //if the user clicks on a miner
     if (mouseX > minerBaseX +(i-1)*minerDistance && mouseX < minerBaseX +(i-1)*minerDistance + minerWidth && mouseY < ( height - (wasteH+rectH) + minerOffsetY) && mouseY > (height - (wasteH+rectH))-39 +minerOffsetY && mousePressed)
     {
       playClick(MinerSnd);//play the miner sound
       startMining = true;//tries to start mining
       tint (255);//and the miner gets highlighted
       toDraw = minerStandbyStatic; //and use the static miner image
     }
   //if the user only mouses over the miner
   else if (mouseX > minerBaseX +(i-1)*minerDistance && mouseX < minerBaseX +(i-1)*minerDistance + minerWidth && mouseY < ( height - (wasteH+rectH) +minerOffsetY ) && mouseY > (height - (wasteH+rectH))-39 +minerOffsetY)
   {
     tint (255);//highlight the miner
     toDraw = minerStandbyStatic; //and use the static miner image
   }
     
   else 
   {
    tint (0);//else the miner must not be highlighted
    toDraw = standbyAnimation; //and use the standby animation
   }
   if(startMining == true ||  reachedMine == true)//if the miners started mining or are in the mine, use the mining animation
    toDraw =miningAnimation;
   

    //if the user clicks on a miner while inside the mine use the static image
    if((startMining == true &&  reachedMine == true) && mouseX > (economyW+(dumpWidth)/2+i*(dumpWidth))-10 && mouseX < (economyW+(dumpWidth)/2+i*(dumpWidth) )-10+38 && mouseY < ( height - (wasteH+rectH)+minerOffsetY) && mouseY > (height - (wasteH+rectH))-39+minerOffsetY && mousePressed )
    {
      toDraw =minerStandbyStatic;//use the static image
      //add up the total for the miners data
      int total = 0;
      for (int j =0; j <5;  j++)
      {
        total += data [i][j];
      }
      
     //display data over miner
     fill(0);
    // text ( total, economyW+(dumpWidth)/2+i*(dumpWidth),  (height - (wasteH+rectH+8)));
    // text ("people", economyW+(dumpWidth)/2+i*(dumpWidth),  (height - (wasteH+rectH-10)));
     //play the sound for the miner
     playClick(BtnSnd);
    }
   
   //make the miner flash in the beginning to lure the user to it
   imageMode(CORNERS);
    if (reachedMine == false && startMining == false)
    {
     tint (c1);
     c1 = c1 + c1dir;
    if (c1 < 0 || c1 > 255) 
    {
     c1dir *= -1;
    }
   
  }
  //and finialy draw the miner
  if(startMining || reachedMine)
  tint (255);
  image (toDraw, minerBaseX +(i-1)*minerDistance,( height - (wasteH+rectH) )+minerOffsetY, minerBaseX +(i-1)*minerDistance+minerWidth, (height - (wasteH+rectH))-39+minerOffsetY);
  
 }
 noTint ();
   
}

//reads the data and labels from the excel sheet, here we also create the bricks of the game frame
void readData ()
{
  int dataMax =0;
  for (int i=0; i<5; i++) 
  {
    for (int j=0; j<5; j++)
    {
     data [i][j] = reader.getInt (4+i,2+j); 
     //float m = map( data [i][j],0,7300,0,360);
     
    }
    dataTotal[0][i] = reader.getInt (9,2+i); 
    dataTotal[1][i] = reader.getInt (4+i,7); 
    dataMax += dataTotal[1][i];
  }
  for (int i =0; i<5; i++)
  {
   labels [i] = reader.getString (4+i,1); 
  }
   // println(dataMax);
    
    for (int i=0; i<5; i++)
    {
      
      dataPercent[0][i] = ((float)dataTotal[0][i])/dataMax*100;
      dataPercent[1][i] = ((float)dataTotal[1][i])/dataMax*100;
      //println(dataPercent[0][i]);
     // println(dataPercent[1][i]);
    }
    
    for(int i = 0;i <3;i++)
    {
      frame.createBricks((int)60);
    }

  
  
}

//draws the structure of the program
void drawStructs()
{
  //draws each block seperately, and changes to the right colour
  bottomrectangles ();

  // draws each quadrilateral speperately, and changes their colour
  minedumps ();
  
  //draw static text
  
          float x = (float)sideBufferX+dumpWidth-120;
          float y = height - (dumpHeight+barDividerY+10);
          
          
  textFont(headingTop);
   fill (255,224,134);    
   text("Mining Waste Threatens\n         my Comminity",x,y-5);  //CHANGE HEADING 2
   text("Mining Drives the Economy",x+dumpWidth*3,y+13);//CHANGE HEADING 2
   textSize(16);
    fill(40);
   text("click miner to start", width/2 -50, height-36);
   text("click pie chart to see values", width/2-75, height-20);

}

//sets the right colour to draw the buildings 
void setColor (int colour)
{
  
  switch (colour)
  {
   case 0: tint(254,159,36); // NORMAL CHANGE!!!!!
   break;
   case 1: tint (207,120,0);
   break;
   case 2: tint (202,58,0);
   break;
   case 3: tint (154,12,0);
   break;
   case 4: tint (84,10,26);
   break;
   case 5: tint (255,179,56); // HIGHLIGHTED CHANGE!!!
   break;
   case 6: tint (227,140,20);
   break;
   case 7: tint (222,78,20);
   break;
   case 8: tint (174,32,20);
   break;
   case 9: tint (104,30,46);
   break;
   case 10: tint (255);
   break;
   default: tint (0);
   break;
  }
   
}

void setFill(int colour)
{
  
  switch (colour)
  {
   case 0: fill(254,159,36); // NORMAL CHANGE!!!!!
   break;
   case 1: fill (207,120,0);
   break;
   case 2: fill (202,58,0);
   break;
   case 3: fill (154,12,0);
   break;
   case 4: fill (84,10,26);
   break;
   case 5: fill (255,179,56); // HIGHLIGHTED CHANGE!!!
   break;
   case 6: fill (227,140,20);
   break;
   case 7: fill (222,78,20);
   break;
   case 8: fill (174,32,20);
   break;
   case 9: fill (104,30,46);
   break;
   case 10: fill (255);
   break;
   default: fill (0);
   break;
  }
   
}
//code taken from http://processing.org/discourse/beta/num_1212093888.html
// Get any angle, between -infinite and +infinite, and clamp it between 0 and 2*PI
float normalizeAngle(float angle)
{
  // First, limit it between -2*PI and 2*PI, using modulo operator
  float na = angle % (2 * PI);
  // If the result is negative, bring it back to 0, 2*PI interval
  if (na < 0) na = 2*PI + na;
  return na;
}

String getStatText(int stat)
{
  String text ="";
  switch (stat)
  {
   case 0: text = "% Strongly Agree";
   break;
   case 1: text = "% Agree";
   break;
   case 2: text = "% Neutral";
   break;
   case 3: text = "% Disagree";
   break;
   case 4: text = "% Strongly Disagree";
   break;

  }
  return text;
   
}

//draws the data/buildings
void drawData()
{
  //Make the buildings grow/build over time
  //if the mine is reached bt the miners and the buildings arn't ther max length yet
  if (reachedMine == true && buildingScaleY <= buildingScaleMax)
  {
   buildingScaleY ++; //increase the height
  } 
  else if(reachedMine == true)//else let the prgoram know we are done building.
  {
    doneBuilding = true;
   
  }
 pieSpinTimer +=0.0005;
 
 if(stickyLeft)
 {
   stickyTimerLeft +=1;
   if(stickyTimerLeft >300)
   {
     stickyTimerLeft = 0;
     stickyLeft = false;
   }
 }

 


 
float lastValue =0.0f;
float currValue =0.0f; 
if(reachedMine)
  for (int i=0; i<2; i++) 
      {
       for (int j=0; j<5; j++)
        {
          currValue = dataPercent[i][j]/100;
          float x = (float)sideBufferX+dumpWidth+i*(dumpWidth*3);
          float y = (float)height - (wasteH*5+rectH-10);
          boolean nearCenter = sqrt(sq(mouseX - x) + sq(mouseY - y)) <= arcD/2;
          float a = normalizeAngle(atan2(mouseY - y, mouseX - x));
          float a1 = lastValue*2*PI+2*PI*pieSpinTimer;
          float a2 = lastValue*2*PI+2*PI*currValue+2*PI*pieSpinTimer;
          
          float na1 = normalizeAngle(a1);
          float na2 = normalizeAngle(a2);
          
          boolean between;
          // First case: small arc, below half of circle
          if (na1 < na2)
          {
            // Just check we are between these two angles
            between = na1 <= a && a <= na2;
          }
          else  // Second case: wide arc, more than half of circle
          {
            // Check we are NOT in the remaining (empty) area...
            between = !(na2 <= a && a <= na1);
          }
          
          if (nearCenter && between) 
          {
           if(mousePressed)
           {
             playClick(ResetSnd);
             stickyTimerLeft = 0;
             stickyLeft =true;
             stickyTextLeft = (int)dataPercent[0][j] + getStatText(j);
             stickyTextRight = (int)dataPercent[1][j] + getStatText(j);
             stickyColourLeft = j;
             
           }
           
          setFill(j+5);
          setColor(j+5);
          } else 
          {
            setFill(j);
            setColor(j);
          }
          
        
          
          
          arc(x,y,arcD*buildingScaleY/100,arcD*buildingScaleY/100,a1,a2,PIE);
          //fill (255,224,134);
         
             textFont(headingTop);
           setFill(stickyColourLeft);
          if(stickyLeft && i ==0)
          {
            text(stickyTextLeft,x-80,height - (dumpHeight-barDividerY-35));//CHANGE TEXT LEFT
          }
          if(stickyLeft && i ==1)
          {
            text(stickyTextRight,x-80,height - (dumpHeight-barDividerY-35)); //CHANGE TEXT RIGHT
          }
          
          lastValue += currValue;
        }
      }
      float minerBaseX = width/2 ;
      float buildingSize = 50;
      float buildingXOffset = -35;
      float buildingYOffset = -2;
      float peopleXSize = 20;
      float peopleYSize = 30;
      float peopleXOffset = 95;
      
      
      for(int i =0; i <3;i++)
      {
        imageMode(CORNERS);
        //draw the ghost buildings that will remain after the buildings get destroyed
        tint(0,0,0,70);
        image(buildingsGhosts[i],minerBaseX +(i-1)*minerDistance+buildingXOffset,height - ((wasteH+rectH+buildingYOffset)+buildingSize*buildingScaleY/100),minerBaseX +(i-1)*minerDistance+40+buildingXOffset,height - (wasteH+rectH+buildingYOffset));
        
        if(doneBuilding == true)//if the buildings are done, resize each building to fit into the value they need to represent
          buildings[i].resize((int)buildingSize,(int)buildingSize);
        
         tint(0);
         image(buildings[i],minerBaseX +(i-1)*minerDistance+buildingXOffset,height - ((wasteH+rectH+buildingYOffset)+buildingSize*buildingScaleY/100),minerBaseX +(i-1)*minerDistance+40+buildingXOffset,height - (wasteH+rectH+buildingYOffset));
      }
      
       for(int i =0; i <2;i++)
      {
        imageMode(CORNERS);

         tint(0);
         image(people[i],minerBaseX +(i-1)*minerDistance/2+peopleXOffset,height - ((wasteH+rectH+buildingYOffset)+peopleYSize*buildingScaleY/100),minerBaseX +(i-1)*minerDistance/2+peopleXSize+peopleXOffset,height - (wasteH+rectH+buildingYOffset));
      }
      
       

  //Draw all of the buildings and handle the user highlighting and clicking on them
  //for each pieces of data in the array
 /* if(false)
  for (int i=0; i<5; i++) 
    {
     for (int j=0; j<5; j++)
      {
        float m = map( data [i][j],0,7300,0,360*buildingScaleY/buildingScaleMax);//map the value to the maximum we want and scale it to buildingScaleY
        imageMode(CORNERS);
        //draw the ghost buildings that will remain after the buildings get destroyed
        tint(0,0,0,70);
        image(buildingsGhosts[i][j],60+j*24+i*dumpWidth+barW,height - ((wasteH+rectH+32)+m),60+j*24+i*dumpWidth,height - (wasteH+rectH+32));
        
        if(doneBuilding == true)//if the buildings are done, resize each building to fit into the value they need to represent
          buildings[i][j].resize(20,(int)m);
        
        //if the user clicks on one of the buildings
        if (mouseX >= 60+j*24+i*dumpWidth && mouseX <= (60+j*24+i*dumpWidth + barW) && mouseY <= height - (wasteH+rectH+32) && mouseY >= height - (wasteH+rectH+32+m)&& mousePressed)
         {
            setColor(10);//highlight it brightly
            //and draw it
            image(buildings[i][j],60+j*24+i*dumpWidth+barW,height - ((wasteH+rectH+32)+m),60+j*24+i*dumpWidth,height - (wasteH+rectH+32));
            
            //also display the data for the seperate bar clicked on
            textAlign (CENTER);
            fill(0);
            text ( data [i][j], economyW+(dumpWidth)/2+i*(dumpWidth),  (height - (wasteH+rectH+8)));
            text (labels[j], economyW+(dumpWidth)/2+i*(dumpWidth),  (height - (wasteH+rectH-10)));
            playClick(BtnSnd);//also play a sound
         } 
     //if the building is simply moused over, lightly highlight it
         else if (mouseX >= 60+j*24+i*dumpWidth && mouseX <= (60+j*24+i*dumpWidth + barW) && mouseY <= height - (wasteH+rectH+32) && mouseY >= height - (wasteH+rectH+32+m))
           {
              setColor(5+j);
              image(buildings[i][j],60+j*24+i*dumpWidth+barW,height - ((wasteH+rectH+32)+m),60+j*24+i*dumpWidth,height - (wasteH+rectH+32));
           } 
     
           else{//else just draw the building with the right colour
                setColor(j);
                image(buildings[i][j],60+j*24+i*dumpWidth+barW,height - ((wasteH+rectH+32)+m),60+j*24+i*dumpWidth,height - (wasteH+rectH+32));
                }
        }
    }*/
}

//adds balls over time to the gameFrames and the mineballs array
void addBalls()
{
  for(int i = 0; i < 5;i++)
  {
    if((ballTimer % ((i+1)*700))==0)
    {//add a ball at intervales, adds them quickly to the first frame and slowly to the last frame
      frame.createBalls();
    }
  }
}

//The reset button to reset all the variables needed to start the program over
void resetButton ()
{
  resetTimer +=1;
  //if moused over, highlight the button by increasing its says and let the user know this resets it
 if (mouseX >40 && mouseX < 60 && mouseY > 40 && mouseY < 60)
  {
    fill(255);
    
    ellipse(50,50,25,25); 
 
  }
  
  //if the button is pressed, reset the program
  if ((mouseX >40 && mouseX < 60 && mouseY > 40 && mouseY < 60 && mousePressed) || resetTimer == 18000)//reset every 5 mins
  {
      startMining = false;
      reachedMine = false;
      doneBuilding = false;
      buildingScaleY = 0;
      minerOffsetY = 0;
      backGroundTime = 0;
      ballTimer = 0;
      playClick(ResetSnd);
      dumpQaudOffset = 0;
      resetTimer = 0;
    
      for (int i=0; i<3; i++) 
      {
      
         buildings[i] = buildingStore[(int)(Math.round(Math.random()*5))].get();  
         buildingsGhosts[i] =buildings[i].get(); 
      
      }
    
    set = 0;

     frame = new GameFrame((int)(400),100,26,buildings); 
   
  
    readData ();
     
    }
    fill(255);
    textFont(status);
    text("Reset", 70, 57);
    ellipse(50,50,20,20); 
}


//play a sound without allowing it to loop while holding the mouse in.
void playClick(AudioSample soundToPlay)
{
  if(playingSound == false)
  {
    soundToPlay.trigger();
    playingSound = true;
  }
 
  
}


